unit NTService;

{
 NTService for Delphi 2 (c)2002 by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.Free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
{
 program Sample;
 uses
  Windows,NTService;

 Const
  Name='SampleSrv';
  Caption='Sample Delphi 2 NT Service';

 procedure main;
  begin
   // put the service code here !
  end;

 begin
  if ParamCount=0 then begin  // just start the service
   Start(Name,Main);
   exit;
  end;
  AllocConsole; // now we have a console application :)
  if ParamStr(1)='/?' then begin
   writeln('Sample [-i|-s|-r]');
   writeln(' (install,start or remove)');
   exit;
  end;
  if ParamStr(1)='-i' then begin
   if Install(Name,Caption,ParamStr(0)) then
    Writeln('service installed ')
   else
    WriteLn('service NOT installed :(');
   exit;
  end;
  if ParamStr(1)='-r' then begin
   if Remove(Name) then
    Writeln('service removed ')
   else
    WriteLn('service NOT removed :(');
   exit;
  end;
  if ParamStr(1)='-s' then begin
   if StartService(Name) then
    Writeln('service started ')
   else
    WriteLn('service NOT started :(');
   exit;
  end;
  writeln('syntax error, try /?');
 end.
}

interface

uses
 Windows;

Type
 TServiceProc=procedure;

const
  EVENTLOG_SUCCESS          = $0000;
  EVENTLOG_ERROR_TYPE       = $0001;
  EVENTLOG_WARNING_TYPE     = $0002;
  EVENTLOG_INFORMATION_TYPE = $0004;
  EVENTLOG_AUDIT_SUCCESS    = $0008;
  EVENTLOG_AUDIT_FAILURE    = $0010;

var
 Stopped         : BOOLEAN;
 Paused          : BOOLEAN;

function Install(Name,Caption,Command:string):boolean;
function Remove(Name:string):boolean;
procedure Start(Name:string; Proc:TServiceProc);
procedure LogEvent(Source,Event:string; EventType:integer);

function StartService(Name:string):boolean;

implementation

//-Install/Remove-------------------------------------------------------------//
function OpenSCManagerA(Machine,DB:PChar; Access:integer):THandle; stdcall external 'advapi32.dll';
function CloseServiceHandle(Handle:THandle):boolean; stdcall external 'advapi32.dll';
function CreateServiceA(
 SCManager:THandle;
 Name,Caption:pchar;
 Access,ServiceType,StartType,ErrorControl:integer;
 PathName,LoadOrderGroup:PChar;
 TagID:pointer {integer};
 Dependencies,StartName,Password:PChar
):THandle; stdcall external 'advapi32.dll';
function OpenServiceA(SCManager:THandle; Name:PChar; Access:integer):THandle; stdcall external 'advapi32.dll';
function StartServiceA(Service:THandle; argc:integer; argv:pointer):boolean; stdcall external 'advapi32.dll';
function DeleteService(Service:THandle):boolean; stdcall external 'advapi32.dll';
const
  SC_MANAGER_CONNECT                  = $0001;
  SC_MANAGER_CREATE_SERVICE           = $0002;
  SC_MANAGER_ENUMERATE_SERVICE        = $0004;
  SC_MANAGER_LOCK                     = $0008;
  SC_MANAGER_QUERY_LOCK_STATUS        = $0010;
  SC_MANAGER_MODIFY_BOOT_CONFIG       = $0020;

  SC_MANAGER_ALL_ACCESS               =
    STANDARD_RIGHTS_REQUIRED or
    SC_MANAGER_CONNECT or
    SC_MANAGER_CREATE_SERVICE or
    SC_MANAGER_ENUMERATE_SERVICE or
    SC_MANAGER_LOCK or
    SC_MANAGER_QUERY_LOCK_STATUS or
    SC_MANAGER_MODIFY_BOOT_CONFIG;
const
  SERVICE_QUERY_CONFIG                = $0001;
  SERVICE_CHANGE_CONFIG               = $0002;
  SERVICE_QUERY_STATUS                = $0004;
  SERVICE_ENUMERATE_DEPENDENTS        = $0008;
  SERVICE_START                       = $0010;
  SERVICE_STOP                        = $0020;
  SERVICE_PAUSE_CONTINUE              = $0040;
  SERVICE_INTERROGATE                 = $0080;
  SERVICE_USER_DEFINED_CONTROL        = $0100;

  SERVICE_ALL_ACCESS                  =
    (STANDARD_RIGHTS_REQUIRED     or
    SERVICE_QUERY_CONFIG         or
    SERVICE_CHANGE_CONFIG        or
    SERVICE_QUERY_STATUS         or
    SERVICE_ENUMERATE_DEPENDENTS or
    SERVICE_START                or
    SERVICE_STOP                 or
    SERVICE_PAUSE_CONTINUE       or
    SERVICE_INTERROGATE          or
    SERVICE_USER_DEFINED_CONTROL);
Const
  SERVICE_WIN32_OWN_PROCESS      = $00000010;
  SERVICE_WIN32_SHARE_PROCESS    = $00000020;
  SERVICE_WIN32                  =
    (SERVICE_WIN32_OWN_PROCESS or
    SERVICE_WIN32_SHARE_PROCESS);
  SERVICE_INTERACTIVE_PROCESS    = $00000100;
const
  SERVICE_BOOT_START             = $00000000;
  SERVICE_SYSTEM_START           = $00000001;
  SERVICE_AUTO_START             = $00000002;
  SERVICE_DEMAND_START           = $00000003;
  SERVICE_DISABLED               = $00000004;
const
  SERVICE_ERROR_IGNORE           = $00000000;
  SERVICE_ERROR_NORMAL           = $00000001;
  SERVICE_ERROR_SEVERE           = $00000002;
  SERVICE_ERROR_CRITICAL         = $00000003;

function Install(Name,Caption,Command:string):boolean;
 var
  scm:THandle;
  srv:THandle;
 begin
  Result:=False;
  scm:=OpenSCManagerA(nil, nil, SC_MANAGER_ALL_ACCESS);
  if scm=0 then exit;
  srv:= CreateServiceA(
   scm,
   PChar(Name), PChar(Caption),
   SERVICE_ALL_ACCESS,
   SERVICE_INTERACTIVE_PROCESS or SERVICE_WIN32_OWN_PROCESS,
   SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL,
   PChar(Command),
   nil, nil, nil, nil, nil
  );
  if srv<>0 then begin
   Result:=True;
   CloseServiceHandle(srv);
  end;
  CloseServiceHandle(scm);
 end;

function Remove(Name:string):boolean;
 var
  scm:THandle;
  srv:THandle;
 begin
  Result:=False;
  scm:=OpenSCManagerA(nil,nil,SC_MANAGER_ALL_ACCESS);
  if scm=0 then exit;
  srv:=OpenServiceA(scm,PChar(Name),SERVICE_ALL_ACCESS);
  if srv<>0 then begin
   Result:=DeleteService(srv);
   CloseServiceHandle(srv);
  end;
  CloseServiceHandle(scm);
 end;

function StartService(Name:string):boolean;
 var
  scm:THandle;
  srv:THandle;
 begin
  Result:=False;
  scm:=OpenSCManagerA(nil,nil,SC_MANAGER_ALL_ACCESS);
  if scm=0 then exit;
  srv:=OpenServiceA(scm,PChar(Name),SERVICE_ALL_ACCESS);
  if srv<>0 then begin
   Result:=StartServiceA(srv,0,nil);
   CloseServiceHandle(srv);
  end;
  CloseServiceHandle(scm);
 end;

//-Start----------------------------------------------------------------------//
Type
 TServiceStatus = packed record
    dwServiceType             : INTEGER;
    dwCurrentState            : INTEGER;
    dwControlsAccepted        : INTEGER;
    dwWin32ExitCode           : INTEGER;
    dwServiceSpecificExitCode : INTEGER;
    dwCheckpoint              : INTEGER;
    dwWaitHint                : INTEGER;
  end;

function RegisterServiceCtrlHandler(Service:PChar; Handler:TFarProc):THandle; stdcall external 'advapi32.dll' name 'RegisterServiceCtrlHandlerA';
function SetServiceStatus(Service:THandle; var Status:TServiceStatus):boolean; stdcall external 'advapi32.dll';

Var
 ServiceName:string;
 MainProc:TServiceProc;
 sshStatusHandle : THandle;
 ssStatus        : TServiceStatus;

const
  SERVICE_CONTROL_STOP                = 1;
  SERVICE_CONTROL_PAUSE               = 2;
  SERVICE_CONTROL_CONTINUE            = 3;
  SERVICE_CONTROL_INTERROGATE         = 4;
  SERVICE_CONTROL_SHUTDOWN            = 5;

const
  SERVICE_STOPPED                     = 1;
  SERVICE_START_PENDING               = 2;
  SERVICE_STOP_PENDING                = 3;
  SERVICE_RUNNING                     = 4;
  SERVICE_CONTINUE_PENDING            = 5;
  SERVICE_PAUSE_PENDING               = 6;
  SERVICE_PAUSED                      = 7;

procedure ServiceHandler (fdwControl : INTEGER); stdcall;
begin
  case fdwControl of
    SERVICE_CONTROL_STOP :
      begin
        // Set flag to indicate to main loop that a stop has been requested
        Stopped := TRUE;
        Paused  := FALSE;

        // Tell SCM we're stopping
        ssStatus.dwCurrentState := SERVICE_STOP_PENDING;
        SetServiceStatus( sshStatusHandle, ssStatus);
      end;
    SERVICE_CONTROL_PAUSE :
      begin
        // Set flag to indicate to main loop that a pause has been requested
        Paused := TRUE;

        // Tell SCM we're paused
        ssStatus.dwCurrentState := SERVICE_PAUSED;
        SetServiceStatus( sshStatusHandle, ssStatus);
      end;
    SERVICE_CONTROL_CONTINUE :
      begin
        // Set flag to indicate to main loop that we're not paused anymore
        Paused := FALSE;

        // Tell SCM we're running again
        ssStatus.dwCurrentState := SERVICE_RUNNING;
        SetServiceStatus( sshStatusHandle, ssStatus);
      end;
    SERVICE_CONTROL_INTERROGATE :
      begin
        // Report current status .
        SetServiceStatus( sshStatusHandle, ssStatus);
      end;
    SERVICE_CONTROL_SHUTDOWN :
      begin
        // NT is shutting down. Not much time available for cleanup.
        Stopped := TRUE;
        Paused  := FALSE;
      end;
  end;
end;

const
  SERVICE_KERNEL_DRIVER          = $00000001;
  SERVICE_FILE_SYSTEM_DRIVER     = $00000002;
  SERVICE_ADAPTER                = $00000004;
  SERVICE_RECOGNIZER_DRIVER      = $00000008;

  SERVICE_DRIVER                 =
    (SERVICE_KERNEL_DRIVER or
    SERVICE_FILE_SYSTEM_DRIVER or
    SERVICE_RECOGNIZER_DRIVER);

  SERVICE_TYPE_ALL               =
    (SERVICE_WIN32  or
    SERVICE_ADAPTER or
    SERVICE_DRIVER  or
    SERVICE_INTERACTIVE_PROCESS);
const
  SERVICE_ACCEPT_STOP                 = 1;
  SERVICE_ACCEPT_PAUSE_CONTINUE       = 2;
  SERVICE_ACCEPT_SHUTDOWN             = 4;

procedure ServiceProc (dwArgC : INTEGER; var lpszArgV : PChar); stdcall;
begin
  // Register our control handler with SCM. First thing to do here.
  sshStatusHandle := RegisterServiceCtrlHandler(PChar(ServiceName), @ServiceHandler);

  if (sshStatusHandle <> 0) then begin
    // Tell SCM that we are starting
    FillChar(ssStatus, SizeOf(ssStatus), #0);
    ssStatus.dwServiceType := SERVICE_WIN32_OWN_PROCESS;
    ssStatus.dwCurrentState := SERVICE_START_PENDING;
    ssStatus.dwControlsAccepted := SERVICE_ACCEPT_STOP or SERVICE_ACCEPT_PAUSE_CONTINUE;
    ssStatus.dwWaitHint := 1000;
    SetServiceStatus( sshStatusHandle, ssStatus);

    // Do whatever initialization is necessarry
    Stopped := FALSE;
    Paused := FALSE;

    // Tell SCM that we are started
    ssStatus.dwCurrentState := SERVICE_RUNNING;
    SetServiceStatus( sshStatusHandle, ssStatus);

    // call back to MainProc (do not return until service ends)
    MainProc;

    // Tell SCM we have stopped
    ssStatus.dwCurrentState := SERVICE_STOPPED;
    SetServiceStatus( sshStatusHandle, ssStatus);
  end;

end;

Type
 TServiceMainFunction = procedure (dwNumServicesArgs : INTEGER; var lpServiceArgVectors : PChar); stdcall;
 TServiceTableEntry = record
    lpServiceName    : PChar;
    lpServiceProc    : TServiceMainFunction;
  end;

function StartServiceCtrlDispatcher(var TAble:TServiceTableEntry):boolean; stdcall external 'advapi32.dll' name 'StartServiceCtrlDispatcherA';

Procedure Start(Name:string; Proc:TServiceProc);
var
  dispatchTable : ARRAY [0..1] OF TServiceTableEntry;
begin
  ServiceName:=Name;
  MainProc:=Proc;
  // Set up dispatchtable for all services in the EXE. Terminate with a
  // nil entry
  dispatchTable[0].lpServiceName := PChar(ServiceName);
  dispatchTable[0].lpServiceProc := @ServiceProc;
  dispatchTable[1].lpServiceName := nil;
  dispatchTable[1].lpServiceProc := nil;

  // Start the service

  // This call will suspend the primary thread which we're in right now,
  // and won't return until the service has been stopped.
  // SCM creates a new thread and calls the address in dispatchTable[0].lpServiceProc,
  // which in our case is ServiceProc
  StartServiceCtrlDispatcher(dispatchTable[0]);
end;

procedure LogEvent(Source,Event:string; EventType:integer);
 var
  src:THandle;
  p:pchar;
 begin
  src:=RegisterEventSource(nil,PChar(Source));
  if src>0 then begin
   p:=pchar(Event);
   ReportEvent(src,EventType,0,0,nil,1,0,p,nil);
   DeregisterEventSource(src);
  end;
 end;

end.
